; Labs 3, Philosophers
; user id: 95 :)
; IDE: RadASM v2.2.1.2
; Resource editor: Restorator 2007
; Compiler: MASM32 v9.0

.586
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\masm32.inc
include \masm32\include\comdlg32.inc
include seh.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\comdlg32.lib

SEH STRUCT 
	SafeEip			dd	?	; The offset where it's safe to continue execution
	PrevEsp			dd	?	; The previous value of esp 
	PrevEbp			dd	?	; The previous value of ebp 
SEH ENDS

IDC_PHILOSOPH1		equ	20
IDC_PHILOSOPH2		equ	21
IDC_PHILOSOPH3		equ	22
IDC_PHILOSOPH4		equ	23
IDC_PHILOSOPH5		equ	24
IDC_STARTBUTTON		equ 1001
IDC_STOPBUTTON		equ 1002
IDC_ABOUTBUTTON		equ 1003
IDC_EXITBUTTON		equ 1004

DlgProc		proto :DWORD, :DWORD, :DWORD, :DWORD
TestStick	proto :DWORD, :DWORD
TakeStick	proto :DWORD
Eat			proto
Think		proto
PutStick	proto :DWORD
Find		proto :DWORD
ThreadFunc	proto :DWORD

.data
	dlgTitle	db "[Labs 3]", 0
	
	Separator	db "%lu", 0
	
	Lib			db "lib.dll", 0
	szGetThreadId	db "GetThreadId", 0
	
	errTitle	db "[Error]", 0
	errText		db "Threads not created!", 0

	abTitle		db "[About]", 0
	abText		db "                      Labs 3", 10, 13
				db "--------------------------------------------", 10, 13
				db "Philosophers", 10, 13
				db "Written on MASM32, pure Win32API", 10, 13
				db "--------------------------------------------", 0

	Thinking	db "Thinking...", 0
	Eating		db "Eating...", 0
	Hungred		db "Hungred", 0
	
	SemaphoreID	db "12345", 0

.data?
	hInstance		HINSTANCE		?
	CriticalSection	RTL_CRITICAL_SECTION	<?>
	seh				SEH	<>
	Current		dd	?
	_GetThreadId	dd	?
	PhID		dd	5	dup(?)
	Ph			dd	5	dup(?)
	Semaphore	dd	5	dup(?)
	State		dd	5	dup(?)

.const
	phThinking	equ	1
	phHungry	equ	2
	phEating	equ	3
	
.code
	Start:
		invoke GetModuleHandle, NULL
		mov hInstance, eax
		invoke DialogBoxParam, eax, 200, NULL, OFFSET DlgProc, NULL
		invoke ExitProcess, NULL

	DlgProc PROC hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
		mov eax, uMsg
		.if eax == WM_INITDIALOG
		
			invoke LoadIcon, hInstance, 666
			invoke SendMessage, hWnd, WM_SETICON, NULL, eax
			invoke SendMessage, hWnd, WM_SETTEXT, NULL, addr dlgTitle
			invoke LoadLibrary, addr Lib
			invoke GetProcAddress, eax, addr szGetThreadId
			mov _GetThreadId, eax 
			mov esi, offset PhID
			mov ebx, offset Ph
			mov edi, 0
			.repeat
				invoke CreateThread, NULL, 1024, addr ThreadFunc, hWnd, CREATE_SUSPENDED, NULL
				mov dword ptr [ebx+edi*4], eax
				push eax
				call _GetThreadId
				mov dword ptr [esi+edi*4], eax
				inc edi
			.until edi == 5
			
			mov edi, 0
			.repeat
				.if dword ptr [ebx+edi*4] == 0
					invoke MessageBox, hWnd, addr errText, addr errTitle, MB_OK or MB_ICONWARNING
				.endif
				invoke SetThreadPriority, dword ptr [ebx+edi*4], THREAD_PRIORITY_NORMAL
				inc edi
			.until edi == 5

			mov ebx, offset Semaphore
			mov esi, offset SemaphoreID
			mov edi, 0
			.repeat
				invoke CreateSemaphore, NULL, NULL, 5, addr byte ptr [esi+edi]
				mov dword ptr [ebx+edi*4], eax 
				inc edi
			.until edi == 5
			
			mov ebx, offset State
			mov edi, 0
			.repeat
				mov dword ptr [ebx+edi*4], phThinking 
				inc edi
			.until edi == 5
			
			invoke GetDlgItem, hWnd, IDC_STOPBUTTON
			invoke EnableWindow, eax, FALSE 
			
			invoke InitializeCriticalSection, addr CriticalSection
			
		.elseif uMsg == WM_LBUTTONDOWN
			
			invoke SendMessage, hWnd, WM_NCLBUTTONDOWN, HTCAPTION, lParam
			
		.elseif eax == WM_COMMAND
		
			mov eax, wParam
			.if ax == IDC_STARTBUTTON
				invoke GetDlgItem, hWnd, IDC_STARTBUTTON
				invoke EnableWindow, eax, FALSE 
				invoke GetDlgItem, hWnd, IDC_STOPBUTTON
				invoke EnableWindow, eax, TRUE 
				mov ebx, offset Ph
				mov edi, 0
				.repeat
					invoke ResumeThread, dword ptr [ebx+edi*4]
					inc edi 
				.until edi == 5
				
			.elseif ax == IDC_STOPBUTTON
				invoke GetDlgItem, hWnd, IDC_STARTBUTTON
				invoke EnableWindow, eax, TRUE 
				invoke GetDlgItem, hWnd, IDC_STOPBUTTON
				invoke EnableWindow, eax, FALSE 
				mov ebx, offset Ph
				mov edi, 0
				.repeat
					invoke SuspendThread, dword ptr [ebx+edi*4]
					inc edi 
				.until edi == 5
				
			.elseif ax == IDC_ABOUTBUTTON
				invoke MessageBoxA, hWnd, addr abText, addr abTitle, MB_OK or MB_ICONINFORMATION
			.elseif ax == IDC_EXITBUTTON
				je @exit
			.endif
		.elseif eax == WM_CLOSE
		
	@exit:	mov esi, offset Ph
			mov edi, 0
			.repeat
				invoke TerminateThread, dword ptr [esi+edi*4], NULL
				 inc edi
			.until edi == 5
			
			mov edx, offset Semaphore
			mov edi, 0
			.repeat
				invoke CloseHandle, dword ptr [edx+edi*4]
				inc edi
			.until edi == 5
			
			invoke DeleteCriticalSection, addr CriticalSection
			invoke EndDialog, hWnd, NULL
		.endif
	@R:	xor eax,eax
		ret
	DlgProc endp
	
	ThreadFunc proc hWnd:DWORD
		.while TRUE
			invoke TakeStick, hWnd
			invoke Eat
			invoke PutStick, hWnd
			invoke Think
		.endw
		ret
	ThreadFunc endp
	
	Think proc
		mov eax, 10000
		call _rand
		invoke Sleep, eax
		ret
	Think endp
	
	Eat proc
		mov eax, 5000
		call _rand
		invoke Sleep, eax
		ret
	Eat endp
	
	TakeStick proc hWnd: DWORD
		invoke Find, hWnd
		mov Current, eax
		invoke EnterCriticalSection, addr CriticalSection
		_try
			mov eax, Current
			mov ebx, offset State
			mov dword ptr [ebx+eax*4], phHungry
			add eax, 20
			invoke SetDlgItemText, hWnd, eax, addr Hungred
			invoke TestStick, hWnd, Current
		_finally
			invoke LeaveCriticalSection, addr CriticalSection
			invoke WaitForSingleObject, Current, INFINITE
		ret
	TakeStick endp
	
	PutStick proc hWnd:DWORD
	LOCAL Left:DWORD
	LOCAL Right:DWORD
		invoke Find, hWnd
		mov Current, eax
		invoke EnterCriticalSection, addr CriticalSection
		_try
			mov eax, Current
			mov ebx, offset State
			mov dword ptr [ebx+eax*4], phThinking
			add eax, 20
			invoke SetDlgItemText, hWnd, eax, addr Thinking
			mov ebx, Current
			inc ebx
			.if ebx == 6
				mov Left, 1
			.elseif
				mov Left, ebx
			.endif
			mov eax, Left
			
			mov ecx, Current
			dec ecx
			.if ecx == 0
				mov Right, 5
			.elseif
				mov Right, ecx
			.endif
			mov ebx, Right
			invoke TestStick, hWnd, eax
			invoke TestStick, hWnd, ebx
		_finally
			invoke LeaveCriticalSection, addr CriticalSection
		ret
	PutStick endp
	
	TestStick proc hWnd: DWORD, Num:DWORD
	LOCAL Left: DWORD
	LOCAL Right: DWORD
		mov eax, Num
		mov Current, eax
		inc eax
		.if eax == 6
			mov Left, 1
		.elseif
			mov Left, eax
		.endif
		mov eax, Left
		mov ebx, Current
		dec ebx
		.if ebx == 0
			mov Right, 5
		.elseif
			mov Right, ebx
		.endif
		mov ebx, Right
		mov esi, offset State
		mov edx, offset Semaphore
		mov edi, Current
		.if (dword ptr [esi+edi*4] == phHungry) && (dword ptr [esi+eax*4] != phEating) && (dword ptr [esi+ebx*4] != phEating) 
			mov dword ptr [esi+edi*4], phEating
			add edi, 20
			invoke SetDlgItemText, hWnd, edi, addr Eating
			invoke ReleaseSemaphore, dword ptr [edx+edi*4], 1, NULL
		.endif
		ret
	TestStick endp

	Find proc hWnd: DWORD
		mov esi, offset Ph
		invoke GetCurrentThreadId
		mov Current, eax
		mov edi, 0
		.repeat
			mov ebx, dword ptr [esi+edi*4]
			push ebx
			call _GetThreadId
			.if Current == eax 
				mov eax, edi
				jmp @ret
			.endif
			inc edi
		.until edi == 5
	@ret:
		ret
	Find endp

	_rand proc uses edx ecx
		push edx
		push ecx
		mov ecx, eax
		xor edx, edx
		rdtsc
		inc eax
		imul eax, eax, 08088405h
		mul eax
		mul ecx
		mov eax, edx
		pop ecx
		pop edx
		ret
	_rand endp

end Start