library GetThreadID_lib;

uses
    Windows;

type
  NTStatus = cardinal;

function ZwQueryInformationThread(ThreadHandle: dword;
                                  ThreadInformationClass: dword;
                                  ThreadInformation: pointer;
                                  ThreadInformationLength: dword;
                                  ReturnLength: pdword): NTStatus;
                                  stdcall;external 'ntdll.dll';

type
  PClientID = ^TClientID;
    TClientID = packed record
      UniqueProcess: Cardinal;
      UniqueThread: Cardinal;
    end;

  PTHREAD_BASIC_INFORMATION = ^THREAD_BASIC_INFORMATION;
    THREAD_BASIC_INFORMATION = packed record
      ExitStatus: Bool;
      TebBaseAddress: Pointer;
      ClientId: TClientID;
      AffinityMask: DWord;
      Priority: DWord;
      BasePriority: DWord;
    end;

const
  THREAD_BASIC_INFO        = $0;
  THREAD_QUERY_INFORMATION = $40;

function GetThreadId(hThread: THandle): Cardinal; stdcall;
var
  tbi: THREAD_BASIC_INFORMATION;
  Status: Cardinal;
  hDupHandle: THandle;
  hCurrentProcess: THandle;
begin
  hCurrentProcess := GetCurrentProcess();
  DuplicateHandle(hCurrentProcess, hThread, hCurrentProcess, @hDupHandle, THREAD_QUERY_INFORMATION, FALSE, 0);
  Status := ZwQueryInformationThread(hDupHandle, THREAD_BASIC_INFO, @tbi, SizeOf(tbi), 0);
  CloseHandle(hDupHandle);
  Result := tbi.ClientId.UniqueThread;
end;

exports
  GetThreadId;

begin
  GetTickCount;
end.
